poj 2135

2024-05-27 13:58
文章标签 poj 2135

本文主要是介绍poj 2135,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

       这道题可以用费用流来解决,在大神看来可能是一道水题,不过对于我这种菜鸟,还是想不到。

       看到这道题,开始想到用两次最短路算法,不过感觉有问题,比如说在某些特殊的情况下,最短路求出的路径可能使得题目无解,具体来说就是如果不走最短路,那么有两条路径,但每条路的权值都比最短路大,如果选择最短路的路径,则不存在另外一条从1到n的路径,即只有最短路径一条路径可走,比如说有一条对角线的矩形,起点和终点在没有对角线的那两个端点上,给予适当的权值就会出现那种情况。后来又想求一个包含房子和仓库的最小环,想在基于Floyd算法求最小环的算法上改改,不过很久没写了,不会了,而且复杂度略高,也放弃了。最后,参考了一下书(《挑战程序设计竞赛》人民邮电出版社 P238),才明白用费用流解决。

      题目给出的边容量都为1,加上一条容量为2,从超级源点指向1顶点的弧, 然后通过费用流选出两条权值和最小的路径。

代码(C++):

#include <cstdlib>
#include <iostream>
#include <queue>#define MAX 1050
#define INF (1<<30)
using namespace std;//#define LOCALstruct Edge{int u;  int v;int cap;int w;int next;  
} edge[MAX*10*2*2];int head[MAX],c,dist[MAX],n,pre[MAX],ans;
bool inq[MAX];void add_edge(int u,int v,int cap,int w)
{edge[c].u=u; edge[c].v=v;edge[c].cap=cap;edge[c].w=w;edge[c].next=head[u];head[u]=c;c++;edge[c].u=v;edge[c].v=u;edge[c].cap=0;edge[c].w=-w;edge[c].next=head[v];head[v]=c;c++;
}void spfa(int s)
{int i,u,v;queue<int> qi;for(i=0;i<=n;i++){dist[i]=INF;inq[i]=false;pre[i]=i;}dist[s]=0;qi.push(s);inq[s]=true;while(!qi.empty()){u=qi.front();qi.pop();inq[u]=false;for(i=head[u];i!=-1;i=edge[i].next){v=edge[i].v;                               if(edge[i].cap>0&&dist[u]+edge[i].w<dist[v]) {dist[v]=dist[u]+edge[i].w;pre[v]=i;if(!inq[v]){qi.push(v);inq[v]=true;       }}                              }              }
}int add_flow(int s,int v,int f)
{int e,d;if(s==v) return f;e=pre[v];d=add_flow(s,edge[e].u,min(f,edge[e].cap));edge[e].cap-=d;edge[e^1].cap+=d;ans+=edge[e].w*d;return d;
}int min_cost_f(int s,int t)
{ans=0;while(1){spfa(s);if(dist[t]==INF) return ans;add_flow(s,t,INF);        }    
}int main(int argc, char *argv[])//源点:0     汇点:n 
{
#ifdef LOCALfreopen("in.txt","r",stdin);freopen("out.txt","w",stdout);
#endifint m,a,b,w,i;while(scanf("%d %d",&n,&m)!=EOF){c=0;memset(head,-1,sizeof(head));            for(i=0;i<m;i++){scanf("%d %d %d",&a,&b,&w);add_edge(a,b,1,w); add_edge(b,a,1,w);          }add_edge(0,1,2,0); printf("%d\n",min_cost_f(0,n));                  }system("PAUSE");return EXIT_SUCCESS;
}

题目( http://poj.org/problem?id=2135):

Farm Tour
Time Limit: 1000MS Memory Limit: 65536K
   

Description

When FJ's friends visit him on the farm, he likes to show them around. His farm comprises N (1 <= N <= 1000) fields numbered 1..N, the first of which contains his house and the Nth of which contains the big barn. A total M (1 <= M <= 10000) paths that connect the fields in various ways. Each path connects two different fields and has a nonzero length smaller than 35,000. 

To show off his farm in the best way, he walks a tour that starts at his house, potentially travels through some fields, and ends at the barn. Later, he returns (potentially through some fields) back to his house again. 

He wants his tour to be as short as possible, however he doesn't want to walk on any given path more than once. Calculate the shortest tour possible. FJ is sure that some tour exists for any given farm.


Input

* Line 1: Two space-separated integers: N and M. 

* Lines 2..M+1: Three space-separated integers that define a path: The starting field, the end field, and the path's length. 


Output

A single line containing the length of the shortest tour. 


Sample Input

4 5
1 2 1
2 3 1
3 4 1
1 3 2
2 4 2


Sample Output

6

这篇关于poj 2135的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/1007675

相关文章

poj 3974 and hdu 3068 最长回文串的O(n)解法(Manacher算法)

求一段字符串中的最长回文串。 因为数据量比较大,用原来的O(n^2)会爆。 小白上的O(n^2)解法代码:TLE啦~ #include<stdio.h>#include<string.h>const int Maxn = 1000000;char s[Maxn];int main(){char e[] = {"END"};while(scanf("%s", s) != EO

hdu 2602 and poj 3624(01背包)

01背包的模板题。 hdu2602代码: #include<stdio.h>#include<string.h>const int MaxN = 1001;int max(int a, int b){return a > b ? a : b;}int w[MaxN];int v[MaxN];int dp[MaxN];int main(){int T;int N, V;s

poj 1511 Invitation Cards(spfa最短路)

题意是给你点与点之间的距离,求来回到点1的最短路中的边权和。 因为边很大,不能用原来的dijkstra什么的,所以用spfa来做。并且注意要用long long int 来存储。 稍微改了一下学长的模板。 stack stl 实现代码: #include<stdio.h>#include<stack>using namespace std;const int M

poj 3259 uva 558 Wormholes(bellman最短路负权回路判断)

poj 3259: 题意:John的农场里n块地,m条路连接两块地,w个虫洞,虫洞是一条单向路,不但会把你传送到目的地,而且时间会倒退Ts。 任务是求你会不会在从某块地出发后又回来,看到了离开之前的自己。 判断树中是否存在负权回路就ok了。 bellman代码: #include<stdio.h>const int MaxN = 501;//农场数const int

poj 1258 Agri-Net(最小生成树模板代码)

感觉用这题来当模板更适合。 题意就是给你邻接矩阵求最小生成树啦。~ prim代码:效率很高。172k...0ms。 #include<stdio.h>#include<algorithm>using namespace std;const int MaxN = 101;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int n

poj 1287 Networking(prim or kruscal最小生成树)

题意给你点与点间距离,求最小生成树。 注意点是,两点之间可能有不同的路,输入的时候选择最小的,和之前有道最短路WA的题目类似。 prim代码: #include<stdio.h>const int MaxN = 51;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int P;int prim(){bool vis[MaxN];

poj 2349 Arctic Network uva 10369(prim or kruscal最小生成树)

题目很麻烦,因为不熟悉最小生成树的算法调试了好久。 感觉网上的题目解释都没说得很清楚,不适合新手。自己写一个。 题意:给你点的坐标,然后两点间可以有两种方式来通信:第一种是卫星通信,第二种是无线电通信。 卫星通信:任何两个有卫星频道的点间都可以直接建立连接,与点间的距离无关; 无线电通信:两个点之间的距离不能超过D,无线电收发器的功率越大,D越大,越昂贵。 计算无线电收发器D

poj 1502 MPI Maelstrom(单源最短路dijkstra)

题目真是长得头疼,好多生词,给跪。 没啥好说的,英语大水逼。 借助字典尝试翻译了一下,水逼直译求不喷 Description: BIT他们的超级计算机最近交货了。(定语秀了一堆词汇那就省略吧再见) Valentine McKee的研究顾问Jack Swigert,要她来测试一下这个系统。 Valentine告诉Swigert:“因为阿波罗是一个分布式共享内存的机器,所以它的内存访问

uva 10061 How many zero's and how many digits ?(不同进制阶乘末尾几个0)+poj 1401

题意是求在base进制下的 n!的结果有几位数,末尾有几个0。 想起刚开始的时候做的一道10进制下的n阶乘末尾有几个零,以及之前有做过的一道n阶乘的位数。 当时都是在10进制下的。 10进制下的做法是: 1. n阶位数:直接 lg(n!)就是得数的位数。 2. n阶末尾0的个数:由于2 * 5 将会在得数中以0的形式存在,所以计算2或者计算5,由于因子中出现5必然出现2,所以直接一

poj 3159 (spfa差分约束最短路) poj 1201

poj 3159: 题意: 每次给出b比a多不多于c个糖果,求n最多比1多多少个糖果。 解析: 差分约束。 这个博客讲差分约束讲的比较好: http://www.cnblogs.com/void/archive/2011/08/26/2153928.html 套个spfa。 代码: #include <iostream>#include <cstdio>#i